#include <avr/io.h>
#include <avr/pgmspace.h>

#include "ps2keyb.h"
#include "adb.h"


#define  ADB_PORT PORTD      //ISPp|[g
#define  ADB_PIN  PIND      //ISPp|[g
#define  ADB_DDR  DDRD       //ISPp|[go͐ݒ

#define	 ADB_MASK	(1<<3)		// ADB

#define	 MARK	0
#define	 SPACE	1

//#define  ADBTIME	25		// 50uS XbVh^C.
#define  ADBTIME	27		// 50uS XbVh^C.


static	uchar	Ereg;

//;--------------------------------------------------------------
//;  `cãXLR[hPOUz̃XLR[hɕϊ
//;--------------------------------------------------------------
//	PROGMEM	unsigned char adb2at[]
#include "table.h"

//;--------------------------------------------------------------
//;  `cãL[Ńs[grbgɈt.
//;--------------------------------------------------------------
PROGMEM	unsigned char KeyRepMask[]=
{
	0B00000000,	//; 0x00
	0B00000000,
	0B00000000,	//; 0x10
	0B00000000,
	0B00000000,	//; 0x20
	0B00000000,
	0B11000000,	//; 0x30
	0B00000111,
	0B00000000,	//; 0x40
	0B00000000,
	0B00000000,	//; 0x50
	0B00000000,
	0B00000000,	//; 0x60
	0B00000000,
	0B00000000,	//; 0x70
	0B00000000,
};

/*
;		KeyPos		0x00`0x7e  keybuflMSB}XN.
;		KeyRow		KeyPos / 8  ̒l(bit tablep)
;		KeyMask		0x01 .. 0x80 ... bitmaskl
;
;		KeyBits[16]	127̊eL[Ă(1)Ă(0)
;				bitŋLXRA{[h
*/
//	128bit
uchar	KeyBits[16];

uchar	KeyPos		;	//;0..88      key number
uchar	KeyRow		;	//;0..11 ---  74159N select signal
uchar	KeyMask		;	// 0x01 .. 0x80 ... bitmaskl

uchar	KeyRepCnt	;	//;L[s[gJE^.
uchar	KeyRepFlag	;	//;L[s[gtO.
uchar	KeyRepCode	;	//;L[s[gL[.

uchar	ScanMode	;
uchar 	KeyREPCLR	;	//;L[Ԃω.

//;--------------------------------------------------------------
//;	KeyPos  KeyRowKeyMaskvZ.
//;--------------------------------------------------------------

uchar KeyBitAdr(uchar b)
{
	KeyPos = b;
	KeyRow = (b>>3)&0x0f;
	KeyMask = 1<< (b&7);
	return KeyRow;
}

//;--------------------------------------------------------------
//;	KeyPosɓrbg(Z tO).
//;--------------------------------------------------------------
uchar KeyBitChk(uchar b)
{
	uchar  n=KeyBitAdr(b);
	return KeyBits[n] & KeyMask;
}
//;--------------------------------------------------------------
//;	KeyPosɓrbg𗧂Ă.
//;--------------------------------------------------------------
void KeyBitSet(uchar b)
{
	uchar  n=KeyBitAdr(b);
	KeyBits[n] |= KeyMask;
}

//;--------------------------------------------------------------
//;	KeyPosɓrbg|.
//;--------------------------------------------------------------
void KeyBitReset(uchar b)
{
	uchar  n=KeyBitAdr(b);
	KeyBits[n] &= ~KeyMask;
}

//;--------------------------------------------------------------
//;	݃XLL[s[gs Not Zero ɂ
//;--------------------------------------------------------------
uchar KeyRepMaskChk(uchar b)
{
	uchar  n=KeyBitAdr(b);
	uchar  r=pgm_read_byte((PGM_P)KeyRepMask + n);
	return r & KeyMask;
}
//;--------------------------------------------------------------
//;	s[^uȃL[܂Ă邩H
//;--------------------------------------------------------------
uchar KeyRepScan(void)
{
	uchar i,c,r;
	for(i=0;i<16;i++) {
		r = pgm_read_byte((PGM_P)KeyRepMask + i);
		r = r ^ 0xff;
		c = KeyBits[i] & r;
		if(c != 0) return 1;
	}
	return 0;
}


//;--------------------------------------------------------------
//	4 * __count  cycles ԑ҂.
//;--------------------------------------------------------------
void delay_loop(uchar __count)
{
	__asm__ volatile (
		"1: dec %0" "\n\t"
		"nop\n\t"
		"brne 1b"
		: "=r" (__count)
		: "0" (__count)
	);
}

void adb_out(uchar c)
{
	if(c) {
		ADB_PORT |= ADB_MASK;
	}else{
		ADB_PORT &= ~ADB_MASK;
	}
	ADB_DDR  |= ADB_MASK;	// o.
}

void adb_inp(void)
{
	ADB_PORT |= ADB_MASK;	// PULL UP
	ADB_DDR &= ~ADB_MASK;	// .
}

void delay_us(uchar us)
{
	delay_loop(us);
	delay_loop(us);
}

void w65us()
{
	delay_us(65);	// 2uS
}

void w800us()
{
	uchar i;
	for(i=0;i<8;i++) {
		delay_us(100);	// 2uS
	}
}

// AeV(800us ̃}[NM𑗂A70us҂)
void adb_atn(void)
{
	adb_out(MARK);
	w800us();
	adb_out(SPACE);
	w65us();
}



//;==============================
//;	PrbgM.
//;==============================
// Cflag=1 bit1𑗐M.
// Cflag=0 bit0𑗐M.
void sadbit(uchar b)
{
	uchar m,s;
	if(b) {
		//     -+   +--------+
		//      +---+        +-
		//      35us   65us
		m=35;s=65;
	}else{
		//     -+        +---+
		//      +--------+   +-
		//       65us     35us
		m=65;s=35;
	}
	adb_out(MARK); delay_us(m);
	adb_out(SPACE);delay_us(s);
}



//;==============================
//;	PoCgM( Breg )
//;==============================

void sadbyte(uchar c)
{
	uchar i;
	for(i=0;i<8;i++,c<<=1) {
		sadbit(c & 0x80);
	}
	sadbit(0);
}



void adb_cmd(uchar c)
{
	adb_atn();
	sadbyte(c);
	adb_inp();
}

void adb_init(void)
{
	uchar i;
	adb_cmd(0);
	for(i=0;i<16;i++) {
		KeyBits[i]=0;
	}
	KeyRepFlag=0;
	KeyRepCnt =0x60	;	//s[gJnJEg_EJE^.
	Ereg =0xff;
}






//;--------------------------------------------------------------
//;	`caM
//;--------------------------------------------------------------
//	READ ADB by ONE BIT (Duty TIME=> C reg) 
uchar cadbited(void);
uchar radbit(void);

//ADB|[gOɂȂ܂ő҂.
uchar cadbitst(void)
{
	uchar i=0;
	do {
//		led(ADB_PIN & ADB_MASK);
		if( (ADB_PIN & ADB_MASK)== 0 ) return i;
		delay_loop(2);	// 2uS
		i++;
	}while(i!=255);
	return 255;
}

//	X^[grbgo.
uchar radbit0(void)
{
	uchar i,n;
	for(i=0;i<2;i++) {
		n=cadbitst();	//X^[grbg҂.
		if(n!=255) {
			return cadbited();
		}
	}
	return 255;
}



//;
//;	PoCgM ==> Ereg
//;
int radbyte(void)
{
	uchar e,b,n;
	e=0;
	for(b=0;b<8;b++) {
		e<<=1;
		n = radbit();if(n==255) return -1;
		if(n < ADBTIME) e |= 1;	//Mbit(Carry)lߋL.
	}
	return e;
}

//;
//;	[vP5 clock = 2uS (10MHz)
//;
/*
	do {
//		led(ADB_PIN & ADB_MASK);
		if(ADB_PIN & ADB_MASK) return i;
 4ae:	83 9b       	sbis	0x10, 3	; 16
 4b0:	03 c0       	rjmp	.+6      	; 0x4b8 <cadbited+0xe>
 4b2:	8c 2f       	mov	r24, r28
 4b4:	99 27       	eor	r25, r25
 4b6:	07 c0       	rjmp	.+14     	; 0x4c6 <cadbited+0x1c>
		delay_loop(4);	// 2uS
 4b8:	84 e0       	ldi	r24, 0x04	; 4
 4ba:	6c df       	rcall	.-296    	; 0x394 <delay_loop>
		i++;
 4bc:	cf 5f       	subi	r28, 0xFF	; 255
	}while(i!=255);
 4be:	cf 3f       	cpi	r28, 0xFF	; 255
 4c0:	b1 f7       	brne	.-20     	; 0x4ae <cadbited+0x4>
	return 255;
*/
uchar cadbited(void)
{
	uchar i=0;
	do {
//		led(ADB_PIN & ADB_MASK);
		if(ADB_PIN & ADB_MASK) return i;
		delay_loop(2);	// 2uS
		i++;
	}while(i!=255);
	return 255;
}
//;
//;	PrbgM ==> Creg MARK̃^CL.
//;		^CI[o[ CarryFLAG=1ɂ.
//;
uchar radbit(void)
{
	uchar n = cadbitst();	// '0'ɂȂ̂҂.
	if(n==255) return 255;
	return cadbited();
}


/*
;	=======================================================
;	`caɃZXR}h𔭍săf[^M.
;
;	ʂ́Akeybuf  Ereg ɓ. (QoCgM邽)
;
;	ʂ̒l͊eL[̌ŗLl(0x00`0x7e)
;	 MSBĂꍇ́ÃL[ꂽCxg.
;	 0xff ԂĂꍇ́AL[CxgȂ.
;	 ɂQoCg̏񂪂ꍇiCxg܂Ăꍇj
;	 ȀꍇAkeybuf݂̂ɓAEreg0xffł邱ƂB
;	=======================================================
 */
int	get_key1(void)
{
	uchar n;
	int c,e;
	Ereg=0xff;		//	 Eregł.
	adb_cmd(0x2c);	//`caZXR}hs.

	n = radbit0();		// X^[grbg擾.
	if(n==255) return -1;

	c = radbyte();		//WrbgM
	if(c == -1) return -1;

	e = radbyte();		//WrbgM
	if(e == -1) return -1;

	radbit(); 			//Xgbvrbg
	Ereg = e;
	return c;
}

int	get_key(void)
{
	uchar c;
#if	1
	if(	Ereg!=0xff) {	// Ereg  Mf[^cĂ̂ŁA̒lԂ.
		c = Ereg;
		Ereg =0xff;
		return c;
	}
#endif
	return get_key1();
}

void KeySend(uchar c)
{
	uchar key;
	uchar f=1;
	if(c & 0x80) f=0;
	c &=0x7f;

	key = pgm_read_byte((PGM_P)adb2at + c);

//	key = 0x75;
	keypress(key,f);
}

void ps2_send(uchar c)
{
//	KeyBitAdr(c);

	if(c & 0x80) {			//ꂽ.
		KeyBitReset(c);
		KeySend(c);
	}else{					//ꂽ.
		KeyBitSet(c);
		KeySend(c);

		//s[g\ȃL[̏ꍇÃR[h߂.
		if( KeyRepMaskChk(c)==0 ) {
			KeyRepCode = c;
		}
	}
}



//L[@s[g.
void adb_repeat(void)
{
	if( KeyREPCLR ) {		//;;ω̂ŁAs[gLZ.
		KeyRepFlag=0;
		KeyRepCnt =0x60;	//s[gJnJEg_EJE^.
		return;
	}

//;s[g\ȃL[A܂Ă邩ǂ𔻒f.
	if( KeyBitChk(KeyRepCode) ) {		//KeyRepCodẽL[͉ĂH.
		KeyRepCnt--;
		if( KeyRepCnt != 0) {	//s[gJnJEgɒB܂Ń[v.
			return;
		}
		KeyRepCnt = 0x0c;	//;s[gJnJEg_EJE^߂.
	
	//;;s[g̎s.
		KeySend(KeyRepCode);
	}
}


void adb_scan(void)
{
//	led(ADB_PIN & ADB_MASK);
	KeyREPCLR = 0;
	int c = get_key();
	if( c != -1) {
		KeyREPCLR = 1;
		ps2_send(c);
	}
//	led(ADB_PIN & ADB_MASK);

	adb_repeat();
}

